hdu 4745 Two Rabbits 最长回文子序列



Description

Long long ago, there lived two rabbits Tom and Jerry in the forest. On a sunny afternoon, they planned to play a game with some stones. There were n stones on the ground and they were arranged as a clockwise ring. That is to say, the first stone was adjacent to the second stone and the n-th stone, and the second stone is adjacent to the first stone and the third stone, and so on. The weight of the i-th stone is ai.  

The rabbits jumped from one stone to another. Tom always jumped clockwise, and Jerry always jumped anticlockwise.  

At the beginning, the rabbits both choose a stone and stand on it. Then at each turn, Tom should choose a stone which have not been stepped by itself and then jumped to it, and Jerry should do the same thing as Tom, but the jumping direction is anti-clockwise.  

For some unknown reason, at any time , the weight of the two stones on which the two rabbits stood should be equal. Besides, any rabbit couldn't jump over a stone which have been stepped by itself. In other words, if the Tom had stood on the second stone, it cannot jump from the first stone to the third stone or from the n-the stone to the 4-th stone.  

Please note that during the whole process, it was OK for the two rabbits to stand on a same stone at the same time.  

Now they want to find out the maximum turns they can play if they follow the optimal strategy.
 

Input

The input contains at most 20 test cases.  
For each test cases, the first line contains a integer n denoting the number of stones.  
The next line contains n integers separated by space, and the i-th integer ai denotes the weight of the i-th stone.(1 <= n <= 1000, 1 <= ai <= 1000)  
The input ends with n = 0.
 

Output

For each test case, print a integer denoting the maximum turns.
 

Sample Input

    
    
1 1 4 1 1 2 1 6 2 1 1 2 1 3 0
 

Sample Output

    
    
1 4 5
题目分析:
根据题意的话,n块石头围一圈。一只兔子顺时针,一只兔子逆时针(限制在一圈的范围内)。如果把数组扩大一倍,再求[i,i+n]之间的最长回文就行了。为什么要这么做呢,[i,i+n]可以满足从任一点开始顺时针走一圈。为什么要求回文呢? 假如存在回文序列,第一个兔子在a点,回文序列里与a对应的点是b点。那么第二个兔子就可以从b点按相反的方向走。最终走到第一个兔子开始的地方。这个过程里兔子前半段跟后半段走的路是一样的。
AC代码:
#include
        
        
         
         
#include
         
         
          
          
#include
          
          
           
           
#include
           
           
            
            
#include
            
            
              #include 
             
               #include 
              
                #include 
               
                 #include 
                
                  #include 
                  #include 
                  
                    #define ll long long #define eps 1e-9 #define pi acos(-1.0) #define lson l,m,rt<<1 #define rson m+1,r,rt<<1|1 #define INF 0x3f3f3f3f #define MAXINT (1<<31)-1 const int M=1000+5; using namespace std; int a[M*2],dp[M*2][M*2]; int n; int dfs(int l,int r) { if(dp[l][r]) return dp[l][r]; if(l==r) return dp[l][r]=1; if(l>r) return 0; dp[l][r]=max(dfs(l,r-1),dfs(l+1,r)); int t; t=dfs(l+1,r-1); if(a[l]==a[r]) t+=2; if(r-l==n) t--; //因为只能走一圈,所以距里不能为n,此时相当于两只兔子从同一起点出发 dp[l][r]=max(t,dp[l][r]); return dp[l][r]; } int main() { while(scanf("%d",&n),n) { int i,j; for(i=1;i<=n;i++) { scanf("%d",&a[i]); a[i+n]=a[i]; } int ans=-10; memset(dp,0,sizeof(dp)); for(i=1;i<=n;i++) ans=max(ans,dfs(i,i+n)); printf("%d\n",ans); } return 0; } 
                   
                 
                
               
              
            
           
           
          
          
         
         
        
        
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值